searchNodes=[{"doc":"Upgrade the icon set used by the application. It fetches the most recent icons from Tabler Icons , extracts them to the vendor directory and, then, runs a script to update some of the properties in the SVG files. $ mix icons","ref":"Mix.Tasks.Icons.html","title":"Mix.Tasks.Icons","type":"task"},{"doc":"Zoonk keeps the contexts that define our domain and business logic. Contexts are also responsible for managing our data, regardless if it comes from the database, an external API or others.","ref":"Zoonk.html","title":"Zoonk","type":"module"},{"doc":"Accounts context. This context manages user accounts, including registration, login, and logout. It's not responsible for school users, which are managed by the Zoonk.Organizations context.","ref":"Zoonk.Accounts.html","title":"Zoonk.Accounts","type":"module"},{"doc":"Emulates that the email will change without actually changing it in the database. Examples iex&gt; apply_user_email ( user , &quot;valid password&quot; , %{ email : ... } ) { :ok , % User { } } iex&gt; apply_user_email ( user , &quot;invalid password&quot; , %{ email : ... } ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Accounts.html#apply_user_email/3","title":"Zoonk.Accounts.apply_user_email/3","type":"function"},{"doc":"Returns an %Ecto.Changeset{} for changing the user email. Examples iex&gt; change_user_email ( user ) % Ecto.Changeset { data : % User { } }","ref":"Zoonk.Accounts.html#change_user_email/2","title":"Zoonk.Accounts.change_user_email/2","type":"function"},{"doc":"Returns an %Ecto.Changeset{} for changing the user password. Examples iex&gt; change_user_password ( user ) % Ecto.Changeset { data : % User { } }","ref":"Zoonk.Accounts.html#change_user_password/2","title":"Zoonk.Accounts.change_user_password/2","type":"function"},{"doc":"Returns an %Ecto.Changeset{} for tracking user changes. Examples iex&gt; change_user_registration ( user ) % Ecto.Changeset { data : % User { } }","ref":"Zoonk.Accounts.html#change_user_registration/2","title":"Zoonk.Accounts.change_user_registration/2","type":"function"},{"doc":"Returns an %Ecto.Changeset{} for changing the user settings. Examples iex&gt; change_user_settings ( user ) % Ecto.Changeset { data : % User { } }","ref":"Zoonk.Accounts.html#change_user_settings/2","title":"Zoonk.Accounts.change_user_settings/2","type":"function"},{"doc":"Confirms a user by the given token. If the token matches, the user account is marked as confirmed and the token is deleted.","ref":"Zoonk.Accounts.html#confirm_user/1","title":"Zoonk.Accounts.confirm_user/1","type":"function"},{"doc":"Deletes the signed token with the given context.","ref":"Zoonk.Accounts.html#delete_user_session_token/1","title":"Zoonk.Accounts.delete_user_session_token/1","type":"function"},{"doc":"Delivers the confirmation email instructions to the given user. Examples iex&gt; deliver_user_confirmation_instructions ( user , &amp; url ( ~p&quot;/users/confirm/ \#{ &amp;1 } &quot; ) ) { :ok , %{ to : ... , body : ... } } iex&gt; deliver_user_confirmation_instructions ( confirmed_user , &amp; url ( ~p&quot;/users/confirm/ \#{ &amp;1 } &quot; ) ) { :error , :already_confirmed }","ref":"Zoonk.Accounts.html#deliver_user_confirmation_instructions/2","title":"Zoonk.Accounts.deliver_user_confirmation_instructions/2","type":"function"},{"doc":"Delivers the reset password email to the given user. Examples iex&gt; deliver_user_reset_password_instructions ( user , &amp; url ( ~p&quot;/users/reset_password/ \#{ &amp;1 } &quot; ) ) { :ok , %{ to : ... , body : ... } }","ref":"Zoonk.Accounts.html#deliver_user_reset_password_instructions/2","title":"Zoonk.Accounts.deliver_user_reset_password_instructions/2","type":"function"},{"doc":"Delivers the update email instructions to the given user. Examples iex&gt; deliver_user_update_email_instructions ( user , current_email , &amp; url ( ~p&quot;/users/settings/confirm_email/ \#{ &amp;1 } )&quot; ) { :ok , %{ to : ... , body : ... } }","ref":"Zoonk.Accounts.html#deliver_user_update_email_instructions/3","title":"Zoonk.Accounts.deliver_user_update_email_instructions/3","type":"function"},{"doc":"Generates a session token.","ref":"Zoonk.Accounts.html#generate_user_session_token/1","title":"Zoonk.Accounts.generate_user_session_token/1","type":"function"},{"doc":"Gets a single user. Raises Ecto.NoResultsError if the User does not exist. Examples iex&gt; get_user! ( 123 ) % User { } iex&gt; get_user! ( 456 ) ** (Ecto.NoResultsError)","ref":"Zoonk.Accounts.html#get_user!/1","title":"Zoonk.Accounts.get_user!/1","type":"function"},{"doc":"Gets a user by email. Examples iex&gt; get_user_by_email ( &quot;foo@example.com&quot; ) % User { } iex&gt; get_user_by_email ( &quot;unknown@example.com&quot; ) nil","ref":"Zoonk.Accounts.html#get_user_by_email/1","title":"Zoonk.Accounts.get_user_by_email/1","type":"function"},{"doc":"Gets a user by either their email address or username. Examples iex&gt; get_user_by_email_or_username ( &quot;foo@example.com&quot; ) % User { } iex&gt; get_user_by_username ( &quot;davinci&quot; ) % User { }","ref":"Zoonk.Accounts.html#get_user_by_email_or_username/1","title":"Zoonk.Accounts.get_user_by_email_or_username/1","type":"function"},{"doc":"Gets a user by email and password. Examples iex&gt; get_user_by_email_or_username_and_password ( &quot;foo@example.com&quot; , &quot;correct_password&quot; ) % User { } iex&gt; get_user_by_email_or_username_and_password ( &quot;adalovelace&quot; , &quot;correct_password&quot; ) % User { } iex&gt; get_user_by_email_or_username_and_password ( &quot;foo@example.com&quot; , &quot;invalid_password&quot; ) nil","ref":"Zoonk.Accounts.html#get_user_by_email_or_username_and_password/2","title":"Zoonk.Accounts.get_user_by_email_or_username_and_password/2","type":"function"},{"doc":"Gets the user by reset password token. Examples iex&gt; get_user_by_reset_password_token ( &quot;validtoken&quot; ) % User { } iex&gt; get_user_by_reset_password_token ( &quot;invalidtoken&quot; ) nil","ref":"Zoonk.Accounts.html#get_user_by_reset_password_token/1","title":"Zoonk.Accounts.get_user_by_reset_password_token/1","type":"function"},{"doc":"Gets the user with the given signed token.","ref":"Zoonk.Accounts.html#get_user_by_session_token/1","title":"Zoonk.Accounts.get_user_by_session_token/1","type":"function"},{"doc":"Gets a user by username. Examples iex&gt; get_user_by_username ( &quot;mariecurie&quot; ) % User { } iex&gt; get_user_by_username ( &quot;unknown&quot; ) nil","ref":"Zoonk.Accounts.html#get_user_by_username/1","title":"Zoonk.Accounts.get_user_by_username/1","type":"function"},{"doc":"Registers a user. Examples iex&gt; register_user ( %{ field : value } ) { :ok , % User { } } iex&gt; register_user ( %{ field : bad_value } ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Accounts.html#register_user/1","title":"Zoonk.Accounts.register_user/1","type":"function"},{"doc":"Resets the user password. Examples iex&gt; reset_user_password ( user , %{ password : &quot;new long password&quot; , password_confirmation : &quot;new long password&quot; } ) { :ok , % User { } } iex&gt; reset_user_password ( user , %{ password : &quot;valid&quot; , password_confirmation : &quot;not the same&quot; } ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Accounts.html#reset_user_password/2","title":"Zoonk.Accounts.reset_user_password/2","type":"function"},{"doc":"Updates the user email using the given token. If the token matches, the user email is updated and the token is deleted. The confirmed_at date is also updated to the current time.","ref":"Zoonk.Accounts.html#update_user_email/2","title":"Zoonk.Accounts.update_user_email/2","type":"function"},{"doc":"Updates the user password. Examples iex&gt; update_user_password ( user , &quot;valid password&quot; , %{ password : ... } ) { :ok , % User { } } iex&gt; update_user_password ( user , &quot;invalid password&quot; , %{ password : ... } ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Accounts.html#update_user_password/3","title":"Zoonk.Accounts.update_user_password/3","type":"function"},{"doc":"Updates the user settings. Examples iex&gt; update_user_settings ( user , %{ username : ... } ) { :ok , % User { } } iex&gt; update_user_settings ( user , %{ username : ... } ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Accounts.html#update_user_settings/2","title":"Zoonk.Accounts.update_user_settings/2","type":"function"},{"doc":"","ref":"Zoonk.Accounts.html#t:user_changeset/0","title":"Zoonk.Accounts.user_changeset/0","type":"type"},{"doc":"Content context.","ref":"Zoonk.Content.html","title":"Zoonk.Content","type":"module"},{"doc":"Approves a course user. Examples iex&gt; approve_course_user ( school_user_id , approved_by_id ) { :ok , % CourseUser { } } iex&gt; approve_course_user ( school_user_id , approved_by_id ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Content.html#approve_course_user/2","title":"Zoonk.Content.approve_course_user/2","type":"function"},{"doc":"Returns an %Ecto.Changeset{} for tracking course changes. Examples iex&gt; change_course ( % Course { } ) % Ecto.Changeset { data : % Course { } }","ref":"Zoonk.Content.html#change_course/2","title":"Zoonk.Content.change_course/2","type":"function"},{"doc":"Returns an %Ecto.Changeset{} for tracking lesson changes. Examples iex&gt; change_lesson ( % Lesson { } ) % Ecto.Changeset { data : % Lesson { } }","ref":"Zoonk.Content.html#change_lesson/2","title":"Zoonk.Content.change_lesson/2","type":"function"},{"doc":"Returns an %Ecto.Changeset{} for tracking lesson step changes. Examples iex&gt; change_lesson_step ( % LessonStep { } ) % Ecto.Changeset { data : % LessonStep { } }","ref":"Zoonk.Content.html#change_lesson_step/2","title":"Zoonk.Content.change_lesson_step/2","type":"function"},{"doc":"Returns an %Ecto.Changeset{} for tracking step option changes. Examples iex&gt; change_step_option ( % StepOption { } ) % Ecto.Changeset { data : % StepOption { } }","ref":"Zoonk.Content.html#change_step_option/2","title":"Zoonk.Content.change_step_option/2","type":"function"},{"doc":"Creates a course. Examples iex&gt; create_course ( %{ field : value } , % User { } ) { :ok , % Course { } } iex&gt; create_course ( %{ field : bad_value } , % User { } ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Content.html#create_course/2","title":"Zoonk.Content.create_course/2","type":"function"},{"doc":"Adds a user to a course. Examples iex&gt; create_course_user ( % Course { } , % User { } , %{ role : :student } ) { :ok , % CourseUser { } } iex&gt; create_course_user ( % Course { } , % User { } , %{ role : :invalid } ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Content.html#create_course_user/3","title":"Zoonk.Content.create_course_user/3","type":"function"},{"doc":"Creates a new lesson. Examples iex&gt; create_lesson ( %{ title : &quot;Lesson 1&quot; } ) { :ok , % Lesson { } } iex&gt; create_lesson ( %{ title : &quot;Lesson 1&quot; } ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Content.html#create_lesson/1","title":"Zoonk.Content.create_lesson/1","type":"function"},{"doc":"Creates a new lesson step. Examples iex&gt; create_lesson_step ( %{ content : &quot;Lesson Step 1&quot; } ) { :ok , % LessonStep { } } iex&gt; create_lesson_step ( %{ content : &quot;Lesson Step 1&quot; } ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Content.html#create_lesson_step/1","title":"Zoonk.Content.create_lesson_step/1","type":"function"},{"doc":"Creates a new step option. Examples iex&gt; create_step_option ( %{ title : &quot;Step Option 1&quot; } ) { :ok , % StepOption { } } iex&gt; create_step_option ( %{ title : &quot;Step Option 1&quot; } ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Content.html#create_step_option/1","title":"Zoonk.Content.create_step_option/1","type":"function"},{"doc":"Deletes a course. Examples iex&gt; delete_course ( % Course { } ) { :ok , % Course { } } iex&gt; delete_course ( % Course { } ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Content.html#delete_course/1","title":"Zoonk.Content.delete_course/1","type":"function"},{"doc":"Deletes a course user. Examples iex&gt; delete_course_user ( course_user_id ) { :ok , % CourseUser { } } iex&gt; delete_course_user ( course_user_id ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Content.html#delete_course_user/1","title":"Zoonk.Content.delete_course_user/1","type":"function"},{"doc":"Deletes a lesson. Examples iex&gt; delete_lesson ( % Lesson { } ) { :ok , % Lesson { } } iex&gt; delete_lesson ( % Lesson { } ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Content.html#delete_lesson/1","title":"Zoonk.Content.delete_lesson/1","type":"function"},{"doc":"Deletes a lesson step. Examples iex&gt; delete_lesson_step ( 123 ) { :ok , % LessonStep { } } iex&gt; delete_lesson_step ( 123 ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Content.html#delete_lesson_step/1","title":"Zoonk.Content.delete_lesson_step/1","type":"function"},{"doc":"Deletes a step option. Examples iex&gt; delete_step_option ( 123 ) { :ok , % StepOption { } } iex&gt; delete_step_option ( 123 ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Content.html#delete_step_option/1","title":"Zoonk.Content.delete_step_option/1","type":"function"},{"doc":"Gets a single course based on the given slug and school ID. Examples iex&gt; get_course_by_slug! ( &quot;slug&quot; , 123 ) % Course { } iex&gt; get_course_by_slug! ( &quot;bad-slug&quot; , 123 ) ** (Ecto.NoResultsError)","ref":"Zoonk.Content.html#get_course_by_slug!/2","title":"Zoonk.Content.get_course_by_slug!/2","type":"function"},{"doc":"Gets the number of students from a course. Examples iex&gt; get_course_students_count ( % Course { } ) 1","ref":"Zoonk.Content.html#get_course_students_count/1","title":"Zoonk.Content.get_course_students_count/1","type":"function"},{"doc":"Get a user from a course given their ID. Examples iex&gt; get_course_user_by_id ( 1 , 1 ) % CourseUser { } iex&gt; get_course_user_by_id ( 0 , 0 ) * * nil","ref":"Zoonk.Content.html#get_course_user_by_id/3","title":"Zoonk.Content.get_course_user_by_id/3","type":"function"},{"doc":"Get a lesson. Examples iex&gt; get_lesson! ( 1 ) % Lesson { }","ref":"Zoonk.Content.html#get_lesson!/1","title":"Zoonk.Content.get_lesson!/1","type":"function"},{"doc":"Get a step option. Examples iex&gt; get_step_option! ( 123 ) % StepOption { }","ref":"Zoonk.Content.html#get_step_option!/1","title":"Zoonk.Content.get_step_option!/1","type":"function"},{"doc":"List all users for a course according to their role. Examples iex&gt; list_course_users_by_role ( % Course { } , :teacher ) [ % CourseUser { } , ... ] iex&gt; list_course_users_by_role ( % Course { } , :student ) [ % CourseUser { } , ... ]","ref":"Zoonk.Content.html#list_course_users_by_role/2","title":"Zoonk.Content.list_course_users_by_role/2","type":"function"},{"doc":"Returns all courses for a given school. This is intended to be used for the management panel. It's ideal for managers and teachers. If you want only published courses, use list_public_courses_by_school/2 instead. Examples iex&gt; list_courses_by_school ( % School { } ) [ % Course { } , ... ]","ref":"Zoonk.Content.html#list_courses_by_school/1","title":"Zoonk.Content.list_courses_by_school/1","type":"function"},{"doc":"List all courses given a user and a role. Examples iex&gt; list_courses_by_user ( % School { } , % User { } , :teacher ) [ % Course { } , ... ] iex&gt; list_courses_by_user ( % School { } , % User { } , :student , limit : 5 ) [ % Course { } , ... ]","ref":"Zoonk.Content.html#list_courses_by_user/4","title":"Zoonk.Content.list_courses_by_user/4","type":"function"},{"doc":"List lesson steps. Examples iex&gt; list_lesson_steps ( % Lesson { } ) [ % LessonStep { } , ... ]","ref":"Zoonk.Content.html#list_lesson_steps/1","title":"Zoonk.Content.list_lesson_steps/1","type":"function"},{"doc":"List course lessons. Examples iex&gt; list_lessons ( % Course { } ) [ % Lesson { } , ... ]","ref":"Zoonk.Content.html#list_lessons/1","title":"Zoonk.Content.list_lessons/1","type":"function"},{"doc":"Returns all public courses for a given school. This is intended to be used for the public API. It's ideal for students and parents. If you want all courses, use list_courses_by_school/1 instead. Examples iex&gt; list_public_courses_by_school ( % School { } ) [ % CourseData { } , ... ]","ref":"Zoonk.Content.html#list_public_courses_by_school/2","title":"Zoonk.Content.list_public_courses_by_school/2","type":"function"},{"doc":"Updates a course. Examples iex&gt; update_course ( % Course { } , %{ field : value } ) { :ok , % Course { } } iex&gt; update_course ( % Course { } , %{ field : bad_value } ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Content.html#update_course/2","title":"Zoonk.Content.update_course/2","type":"function"},{"doc":"Updates a course user. Examples iex&gt; update_course_user ( % CourseUser { } , %{ role : :student } ) { :ok , % CourseUser { } } iex&gt; update_course_user ( % CourseUser { } , %{ role : :invalid } ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Content.html#update_course_user/2","title":"Zoonk.Content.update_course_user/2","type":"function"},{"doc":"Updates a lesson. Examples iex&gt; update_lesson ( % Lesson { } , %{ name : &quot;Lesson 1&quot; } ) { :ok , % Lesson { } } iex&gt; update_lesson ( % Lesson { } , %{ name : &quot;Lesson 1&quot; } ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Content.html#update_lesson/2","title":"Zoonk.Content.update_lesson/2","type":"function"},{"doc":"Update lessons order. Reposition all lessons between an interval when a lesson is moved. Examples iex&gt; update_lesson_order ( % Course { } , 1 , 3 ) { :ok , [ % Lesson { } , ... ] }","ref":"Zoonk.Content.html#update_lesson_order/3","title":"Zoonk.Content.update_lesson_order/3","type":"function"},{"doc":"Update lesson steps order. Reposition all lesson steps between an interval when a lesson step is moved. Examples iex&gt; update_lesson_step_order ( % Lesson { } , 1 , 3 ) { :ok , [ % LessonStep { } , ... ] }","ref":"Zoonk.Content.html#update_lesson_step_order/3","title":"Zoonk.Content.update_lesson_step_order/3","type":"function"},{"doc":"Update a step option. Examples iex&gt; update_step_option ( % StepOption { } , %{ title : &quot;Step Option 1&quot; } ) { :ok , % StepOption { } } iex&gt; update_step_option ( % StepOption { } , %{ title : &quot;Step Option 1&quot; } ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Content.html#update_step_option/2","title":"Zoonk.Content.update_step_option/2","type":"function"},{"doc":"","ref":"Zoonk.Content.html#t:course_changeset/0","title":"Zoonk.Content.course_changeset/0","type":"type"},{"doc":"","ref":"Zoonk.Content.html#t:course_user_changeset/0","title":"Zoonk.Content.course_user_changeset/0","type":"type"},{"doc":"","ref":"Zoonk.Content.html#t:lesson_changeset/0","title":"Zoonk.Content.lesson_changeset/0","type":"type"},{"doc":"","ref":"Zoonk.Content.html#t:lesson_step_changeset/0","title":"Zoonk.Content.lesson_step_changeset/0","type":"type"},{"doc":"","ref":"Zoonk.Content.html#t:step_option_changeset/0","title":"Zoonk.Content.step_option_changeset/0","type":"type"},{"doc":"Mailer service for Zoonk.","ref":"Zoonk.Mailer.html","title":"Zoonk.Mailer","type":"module"},{"doc":"","ref":"Zoonk.Mailer.html#deliver/2","title":"Zoonk.Mailer.deliver/2","type":"function"},{"doc":"","ref":"Zoonk.Mailer.html#deliver!/2","title":"Zoonk.Mailer.deliver!/2","type":"function"},{"doc":"","ref":"Zoonk.Mailer.html#deliver_many/2","title":"Zoonk.Mailer.deliver_many/2","type":"function"},{"doc":"Organizations context.","ref":"Zoonk.Organizations.html","title":"Zoonk.Organizations","type":"module"},{"doc":"Approves a school user. Examples iex&gt; approve_school_user ( school_user_id ) { :ok , % SchoolUser { } } iex&gt; approve_school_user ( school_user_id ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Organizations.html#approve_school_user/2","title":"Zoonk.Organizations.approve_school_user/2","type":"function"},{"doc":"Returns an %Ecto.Changeset{} for tracking school changes. Examples iex&gt; change_school ( school ) % Ecto.Changeset { data : % School { } }","ref":"Zoonk.Organizations.html#change_school/2","title":"Zoonk.Organizations.change_school/2","type":"function"},{"doc":"Creates a school. Examples iex&gt; create_school ( user , %{ field : value } ) { :ok , % School { } } iex&gt; create_school ( user , %{ field : bad_value } ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Organizations.html#create_school/2","title":"Zoonk.Organizations.create_school/2","type":"function"},{"doc":"Adds a user to a school. Examples iex&gt; create_school_user ( school , user , %{ role : :student } ) { :ok , % SchoolUser { } } iex&gt; create_school_user ( school , user , %{ role : :invalid } ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Organizations.html#create_school_user/4","title":"Zoonk.Organizations.create_school_user/4","type":"function"},{"doc":"Deletes a school. Examples iex&gt; delete_school ( school , school_user ) { :ok , % School { } } iex&gt; delete_school ( school , school_user ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Organizations.html#delete_school/1","title":"Zoonk.Organizations.delete_school/1","type":"function"},{"doc":"Deletes a school user. Examples iex&gt; delete_school_user ( school_user_id ) { :ok , % SchoolUser { } } iex&gt; delete_school_user ( school_user_id ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Organizations.html#delete_school_user/1","title":"Zoonk.Organizations.delete_school_user/1","type":"function"},{"doc":"Gets the number of courses a school has. It includes courses from child schools. Examples iex&gt; get_courses_count ( school ) 10","ref":"Zoonk.Organizations.html#get_courses_count/1","title":"Zoonk.Organizations.get_courses_count/1","type":"function"},{"doc":"Gets the parent school of a school. Examples iex&gt; get_parent_school ( school ) % School { }","ref":"Zoonk.Organizations.html#get_parent_school/1","title":"Zoonk.Organizations.get_parent_school/1","type":"function"},{"doc":"Gets a single school. Raises Ecto.NoResultsError if the School does not exist. Examples iex&gt; get_school! ( 123 ) % School { } iex&gt; get_school! ( 456 ) ** (Ecto.NoResultsError)","ref":"Zoonk.Organizations.html#get_school!/1","title":"Zoonk.Organizations.get_school!/1","type":"function"},{"doc":"Gets a single school based on the host value. Examples iex&gt; get_school_by_host! ( &quot;unisc.zoonk.org&quot; ) % School { } iex&gt; get_school_by_host! ( &quot;interactive.rug.nl&quot; ) % School { } iex&gt; get_school_by_host! ( &quot;nonexisting.com&quot; ) nil","ref":"Zoonk.Organizations.html#get_school_by_host!/1","title":"Zoonk.Organizations.get_school_by_host!/1","type":"function"},{"doc":"Gets a single school based on their username. Examples iex&gt; get_school_by_username! ( &quot;unisc&quot; ) % School { } iex&gt; get_school_by_username! ( &quot;nonexisting&quot; ) ** (Ecto.NoResultsError)","ref":"Zoonk.Organizations.html#get_school_by_username!/1","title":"Zoonk.Organizations.get_school_by_username!/1","type":"function"},{"doc":"Get a user from a school given their usernames. Examples iex&gt; get_school_user ( &quot;zoonk&quot; , &quot;will&quot; ) % SchoolUser { } iex&gt; get_school_user ( &quot;zoonk&quot; , &quot;invalid&quot; ) nil","ref":"Zoonk.Organizations.html#get_school_user/3","title":"Zoonk.Organizations.get_school_user/3","type":"function"},{"doc":"Gets the number of users in a school based on their role. Examples iex&gt; get_school_users_count ( school , :manager ) 10","ref":"Zoonk.Organizations.html#get_school_users_count/2","title":"Zoonk.Organizations.get_school_users_count/2","type":"function"},{"doc":"Gets the number of schools a parent school has. Examples iex&gt; get_schools_count ( school ) 10","ref":"Zoonk.Organizations.html#get_schools_count/1","title":"Zoonk.Organizations.get_schools_count/1","type":"function"},{"doc":"Returns true if a school has any child schools. Examples iex&gt; has_child_schools? ( school ) true","ref":"Zoonk.Organizations.html#has_child_schools?/1","title":"Zoonk.Organizations.has_child_schools?/1","type":"function"},{"doc":"Returns a list of public schools. If you want to list schools specific to a user, you should use list_schools_by_user/1 instead. Examples iex&gt; list_public_schools ( ) [ % SchoolData { } , ... ]","ref":"Zoonk.Organizations.html#list_public_schools/1","title":"Zoonk.Organizations.list_public_schools/1","type":"function"},{"doc":"List all users for a school. Examples iex&gt; list_school_users ( school ) [ % User { } , ... ]","ref":"Zoonk.Organizations.html#list_school_users/1","title":"Zoonk.Organizations.list_school_users/1","type":"function"},{"doc":"List all users for a school according to their role. Examples iex&gt; list_school_users_by_role ( school , :manager ) [ % SchoolUser { } , ... ]","ref":"Zoonk.Organizations.html#list_school_users_by_role/2","title":"Zoonk.Organizations.list_school_users_by_role/2","type":"function"},{"doc":"List all schools a user belongs to. Examples iex&gt; list_schools_by_user ( % User { } ) [ % SchoolUser { } , ... ]","ref":"Zoonk.Organizations.html#list_schools_by_user/2","title":"Zoonk.Organizations.list_schools_by_user/2","type":"function"},{"doc":"Updates a school. Examples iex&gt; update_school ( school , %{ field : new_value } ) { :ok , % School { } } iex&gt; update_school ( school , %{ field : bad_value } ) { :error , % Ecto.Changeset { } }","ref":"Zoonk.Organizations.html#update_school/2","title":"Zoonk.Organizations.update_school/2","type":"function"},{"doc":"","ref":"Zoonk.Organizations.html#t:school_changeset/0","title":"Zoonk.Organizations.school_changeset/0","type":"type"},{"doc":"","ref":"Zoonk.Organizations.html#t:school_user_changeset/0","title":"Zoonk.Organizations.school_user_changeset/0","type":"type"},{"doc":"Defines a repository module for Ecto. It uses Ecto.Repo to define the repository behavior using the Ecto.Adapters.Postgres adapter.","ref":"Zoonk.Repo.html","title":"Zoonk.Repo","type":"module"},{"doc":"Callback implementation for Ecto.Repo.aggregate/3 .","ref":"Zoonk.Repo.html#aggregate/3","title":"Zoonk.Repo.aggregate/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.aggregate/4 .","ref":"Zoonk.Repo.html#aggregate/4","title":"Zoonk.Repo.aggregate/4","type":"function"},{"doc":"Callback implementation for Ecto.Repo.all/2 .","ref":"Zoonk.Repo.html#all/2","title":"Zoonk.Repo.all/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.checked_out?/0 .","ref":"Zoonk.Repo.html#checked_out?/0","title":"Zoonk.Repo.checked_out?/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.checkout/2 .","ref":"Zoonk.Repo.html#checkout/2","title":"Zoonk.Repo.checkout/2","type":"function"},{"doc":"","ref":"Zoonk.Repo.html#child_spec/1","title":"Zoonk.Repo.child_spec/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.config/0 .","ref":"Zoonk.Repo.html#config/0","title":"Zoonk.Repo.config/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.default_options/1 .","ref":"Zoonk.Repo.html#default_options/1","title":"Zoonk.Repo.default_options/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.delete/2 .","ref":"Zoonk.Repo.html#delete/2","title":"Zoonk.Repo.delete/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.delete!/2 .","ref":"Zoonk.Repo.html#delete!/2","title":"Zoonk.Repo.delete!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.delete_all/2 .","ref":"Zoonk.Repo.html#delete_all/2","title":"Zoonk.Repo.delete_all/2","type":"function"},{"doc":"A convenience function for SQL-based repositories that forces all connections in the pool to disconnect within the given interval. See Ecto.Adapters.SQL.disconnect_all/3 for more information.","ref":"Zoonk.Repo.html#disconnect_all/2","title":"Zoonk.Repo.disconnect_all/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.exists?/2 .","ref":"Zoonk.Repo.html#exists?/2","title":"Zoonk.Repo.exists?/2","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes an EXPLAIN statement or similar depending on the adapter to obtain statistics for the given query. See Ecto.Adapters.SQL.explain/4 for more information.","ref":"Zoonk.Repo.html#explain/3","title":"Zoonk.Repo.explain/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get/3 .","ref":"Zoonk.Repo.html#get/3","title":"Zoonk.Repo.get/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get!/3 .","ref":"Zoonk.Repo.html#get!/3","title":"Zoonk.Repo.get!/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get_by/3 .","ref":"Zoonk.Repo.html#get_by/3","title":"Zoonk.Repo.get_by/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get_by!/3 .","ref":"Zoonk.Repo.html#get_by!/3","title":"Zoonk.Repo.get_by!/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get_dynamic_repo/0 .","ref":"Zoonk.Repo.html#get_dynamic_repo/0","title":"Zoonk.Repo.get_dynamic_repo/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.in_transaction?/0 .","ref":"Zoonk.Repo.html#in_transaction?/0","title":"Zoonk.Repo.in_transaction?/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert/2 .","ref":"Zoonk.Repo.html#insert/2","title":"Zoonk.Repo.insert/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert!/2 .","ref":"Zoonk.Repo.html#insert!/2","title":"Zoonk.Repo.insert!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert_all/3 .","ref":"Zoonk.Repo.html#insert_all/3","title":"Zoonk.Repo.insert_all/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert_or_update/2 .","ref":"Zoonk.Repo.html#insert_or_update/2","title":"Zoonk.Repo.insert_or_update/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert_or_update!/2 .","ref":"Zoonk.Repo.html#insert_or_update!/2","title":"Zoonk.Repo.insert_or_update!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.load/2 .","ref":"Zoonk.Repo.html#load/2","title":"Zoonk.Repo.load/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.one/2 .","ref":"Zoonk.Repo.html#one/2","title":"Zoonk.Repo.one/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.one!/2 .","ref":"Zoonk.Repo.html#one!/2","title":"Zoonk.Repo.one!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.preload/3 .","ref":"Zoonk.Repo.html#preload/3","title":"Zoonk.Repo.preload/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.prepare_query/3 .","ref":"Zoonk.Repo.html#prepare_query/3","title":"Zoonk.Repo.prepare_query/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.put_dynamic_repo/1 .","ref":"Zoonk.Repo.html#put_dynamic_repo/1","title":"Zoonk.Repo.put_dynamic_repo/1","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given query. See Ecto.Adapters.SQL.query/4 for more information.","ref":"Zoonk.Repo.html#query/3","title":"Zoonk.Repo.query/3","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given query. See Ecto.Adapters.SQL.query!/4 for more information.","ref":"Zoonk.Repo.html#query!/3","title":"Zoonk.Repo.query!/3","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given multi-result query. See Ecto.Adapters.SQL.query_many/4 for more information.","ref":"Zoonk.Repo.html#query_many/3","title":"Zoonk.Repo.query_many/3","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given multi-result query. See Ecto.Adapters.SQL.query_many!/4 for more information.","ref":"Zoonk.Repo.html#query_many!/3","title":"Zoonk.Repo.query_many!/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.reload/2 .","ref":"Zoonk.Repo.html#reload/2","title":"Zoonk.Repo.reload/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.reload!/2 .","ref":"Zoonk.Repo.html#reload!/2","title":"Zoonk.Repo.reload!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.rollback/1 .","ref":"Zoonk.Repo.html#rollback/1","title":"Zoonk.Repo.rollback/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.start_link/1 .","ref":"Zoonk.Repo.html#start_link/1","title":"Zoonk.Repo.start_link/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.stop/1 .","ref":"Zoonk.Repo.html#stop/1","title":"Zoonk.Repo.stop/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.stream/2 .","ref":"Zoonk.Repo.html#stream/2","title":"Zoonk.Repo.stream/2","type":"function"},{"doc":"A convenience function for SQL-based repositories that translates the given query to SQL. See Ecto.Adapters.SQL.to_sql/3 for more information.","ref":"Zoonk.Repo.html#to_sql/2","title":"Zoonk.Repo.to_sql/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.transaction/2 .","ref":"Zoonk.Repo.html#transaction/2","title":"Zoonk.Repo.transaction/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.update/2 .","ref":"Zoonk.Repo.html#update/2","title":"Zoonk.Repo.update/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.update!/2 .","ref":"Zoonk.Repo.html#update!/2","title":"Zoonk.Repo.update!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.update_all/3 .","ref":"Zoonk.Repo.html#update_all/3","title":"Zoonk.Repo.update_all/3","type":"function"},{"doc":"The entrypoint for defining our web interface, such as controllers, components, channels, and so on. This can be used as: use ZoonkWeb , :controller use ZoonkWeb , :html The definitions below will be executed for every controller, component, etc, so keep them short and clean, focused on imports, uses and aliases. Do NOT define functions inside the quoted expressions below. Instead, define additional modules and import those modules here.","ref":"ZoonkWeb.html","title":"ZoonkWeb","type":"module"},{"doc":"When used, dispatch to the appropriate controller/view/etc.","ref":"ZoonkWeb.html#__using__/1","title":"ZoonkWeb.__using__/1","type":"macro"},{"doc":"Define a channel module. Examples defmodule ZoonkWeb.UserSocket do use ZoonkWeb , :channel ... end","ref":"ZoonkWeb.html#channel/0","title":"ZoonkWeb.channel/0","type":"function"},{"doc":"Define a controller module. It uses the Phoenix.Controller module. Examples defmodule ZoonkWeb.PageController do use ZoonkWeb , :controller ... end","ref":"ZoonkWeb.html#controller/0","title":"ZoonkWeb.controller/0","type":"function"},{"doc":"Define an html module. It uses the Phoenix.Component module. Examples defmodule ZoonkWeb.PageView do use ZoonkWeb , :html ... end","ref":"ZoonkWeb.html#html/0","title":"ZoonkWeb.html/0","type":"function"},{"doc":"Define a live_component module. It uses the Phoenix.LiveComponent module. Examples defmodule ZoonkWeb.Components.Modal do use ZoonkWeb , :live_component ... end","ref":"ZoonkWeb.html#live_component/0","title":"ZoonkWeb.live_component/0","type":"function"},{"doc":"Define a live_view module. It uses the Phoenix.LiveView module. Examples defmodule ZoonkWeb.PageLive do use ZoonkWeb , :live_view ... end","ref":"ZoonkWeb.html#live_view/0","title":"ZoonkWeb.live_view/0","type":"function"},{"doc":"Define a router module. It uses the Phoenix.Router module. Examples defmodule ZoonkWeb.Router do use ZoonkWeb , :router ... end","ref":"ZoonkWeb.html#router/0","title":"ZoonkWeb.router/0","type":"function"},{"doc":"List of paths that can be used to render static assets. Files in these paths can be accessed using verified routes: ~p&quot;/images/logo.png&quot; .","ref":"ZoonkWeb.html#static_paths/0","title":"ZoonkWeb.static_paths/0","type":"function"},{"doc":"Define a verified_routes module. It uses the Phoenix.VerifiedRoutes module. Examples defmodule ZoonkWeb.Plugs.UserAuth do use ZoonkWeb , :verified_routes ... end","ref":"ZoonkWeb.html#verified_routes/0","title":"ZoonkWeb.verified_routes/0","type":"function"},{"doc":"The Phoenix endpoint, handling HTTP requests. It uses Phoenix.Endpoint to define: The HTTP interface and dispatch pipeline The socket transport options The LiveView socket transport options The LiveDashboard socket transport options The session store The code reloading configuration The static file serving configuration","ref":"ZoonkWeb.Endpoint.html","title":"ZoonkWeb.Endpoint","type":"module"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast/3 .","ref":"ZoonkWeb.Endpoint.html#broadcast/3","title":"ZoonkWeb.Endpoint.broadcast/3","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast!/3 .","ref":"ZoonkWeb.Endpoint.html#broadcast!/3","title":"ZoonkWeb.Endpoint.broadcast!/3","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast_from/4 .","ref":"ZoonkWeb.Endpoint.html#broadcast_from/4","title":"ZoonkWeb.Endpoint.broadcast_from/4","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast_from!/4 .","ref":"ZoonkWeb.Endpoint.html#broadcast_from!/4","title":"ZoonkWeb.Endpoint.broadcast_from!/4","type":"function"},{"doc":"Callback implementation for Plug.call/2 .","ref":"ZoonkWeb.Endpoint.html#call/2","title":"ZoonkWeb.Endpoint.call/2","type":"function"},{"doc":"Returns the child specification to start the endpoint under a supervision tree.","ref":"ZoonkWeb.Endpoint.html#child_spec/1","title":"ZoonkWeb.Endpoint.child_spec/1","type":"function"},{"doc":"Returns the endpoint configuration for key Returns default if the key does not exist.","ref":"ZoonkWeb.Endpoint.html#config/2","title":"ZoonkWeb.Endpoint.config/2","type":"function"},{"doc":"Reloads the configuration given the application environment changes.","ref":"ZoonkWeb.Endpoint.html#config_change/2","title":"ZoonkWeb.Endpoint.config_change/2","type":"function"},{"doc":"Returns the host for the given endpoint.","ref":"ZoonkWeb.Endpoint.html#host/0","title":"ZoonkWeb.Endpoint.host/0","type":"function"},{"doc":"Callback implementation for Plug.init/1 .","ref":"ZoonkWeb.Endpoint.html#init/1","title":"ZoonkWeb.Endpoint.init/1","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.local_broadcast/3 .","ref":"ZoonkWeb.Endpoint.html#local_broadcast/3","title":"ZoonkWeb.Endpoint.local_broadcast/3","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.local_broadcast_from/4 .","ref":"ZoonkWeb.Endpoint.html#local_broadcast_from/4","title":"ZoonkWeb.Endpoint.local_broadcast_from/4","type":"function"},{"doc":"Generates the path information when routing to this endpoint.","ref":"ZoonkWeb.Endpoint.html#path/1","title":"ZoonkWeb.Endpoint.path/1","type":"function"},{"doc":"Generates the script name.","ref":"ZoonkWeb.Endpoint.html#script_name/0","title":"ZoonkWeb.Endpoint.script_name/0","type":"function"},{"doc":"Starts the endpoint supervision tree. All other options are merged into the endpoint configuration.","ref":"ZoonkWeb.Endpoint.html#start_link/1","title":"ZoonkWeb.Endpoint.start_link/1","type":"function"},{"doc":"Generates a base64-encoded cryptographic hash (sha512) to a static file in priv/static . Meant to be used for Subresource Integrity with CDNs.","ref":"ZoonkWeb.Endpoint.html#static_integrity/1","title":"ZoonkWeb.Endpoint.static_integrity/1","type":"function"},{"doc":"Returns a two item tuple with the first item being the static_path and the second item being the static_integrity .","ref":"ZoonkWeb.Endpoint.html#static_lookup/1","title":"ZoonkWeb.Endpoint.static_lookup/1","type":"function"},{"doc":"Generates a route to a static file in priv/static .","ref":"ZoonkWeb.Endpoint.html#static_path/1","title":"ZoonkWeb.Endpoint.static_path/1","type":"function"},{"doc":"Generates the static URL without any path information. It uses the configuration under :static_url to generate such. It falls back to :url if :static_url is not set.","ref":"ZoonkWeb.Endpoint.html#static_url/0","title":"ZoonkWeb.Endpoint.static_url/0","type":"function"},{"doc":"Generates the endpoint base URL but as a URI struct. It uses the configuration under :url to generate such. Useful for manipulating the URL data and passing it to URL helpers.","ref":"ZoonkWeb.Endpoint.html#struct_url/0","title":"ZoonkWeb.Endpoint.struct_url/0","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.subscribe/2 .","ref":"ZoonkWeb.Endpoint.html#subscribe/2","title":"ZoonkWeb.Endpoint.subscribe/2","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.unsubscribe/1 .","ref":"ZoonkWeb.Endpoint.html#unsubscribe/1","title":"ZoonkWeb.Endpoint.unsubscribe/1","type":"function"},{"doc":"Generates the endpoint base URL without any path information. It uses the configuration under :url to generate such.","ref":"ZoonkWeb.Endpoint.html#url/0","title":"ZoonkWeb.Endpoint.url/0","type":"function"},{"doc":"Phoenix View for the error page.","ref":"ZoonkWeb.ErrorHTML.html","title":"ZoonkWeb.ErrorHTML","type":"module"},{"doc":"","ref":"ZoonkWeb.ErrorHTML.html#403/1","title":"ZoonkWeb.ErrorHTML.403/1","type":"function"},{"doc":"","ref":"ZoonkWeb.ErrorHTML.html#404/1","title":"ZoonkWeb.ErrorHTML.404/1","type":"function"},{"doc":"","ref":"ZoonkWeb.ErrorHTML.html#500/1","title":"ZoonkWeb.ErrorHTML.500/1","type":"function"},{"doc":"Returns the browser's locale.","ref":"ZoonkWeb.ErrorHTML.html#get_locale/1","title":"ZoonkWeb.ErrorHTML.get_locale/1","type":"function"},{"doc":"Returns the school name based on the host.","ref":"ZoonkWeb.ErrorHTML.html#school_name/1","title":"ZoonkWeb.ErrorHTML.school_name/1","type":"function"},{"doc":"Translate a string from the error page using the browser's locale. To render the error page, we can't access the session. We get the locale from the browser's accept-language header using Gettext module. To avoid affecting the entire application, we use Gettext.with_locale/2 to temporarily set the locale and dynamically translate messages with Gettext.dgettext/3.","ref":"ZoonkWeb.ErrorHTML.html#translate_message/3","title":"ZoonkWeb.ErrorHTML.translate_message/3","type":"function"},{"doc":"Render an error for a JSON request. If you want to customize a particular status code, you may add your own clauses, such as: def render ( &quot;500.json&quot; , _assigns ) do %{ errors : %{ detail : &quot;Internal Server Error&quot; } } end By default, Phoenix returns the status message from the template name. For example, &quot;404.json&quot; becomes &quot;Not Found&quot;.","ref":"ZoonkWeb.ErrorJSON.html","title":"ZoonkWeb.ErrorJSON","type":"module"},{"doc":"","ref":"ZoonkWeb.ErrorJSON.html#render/2","title":"ZoonkWeb.ErrorJSON.render/2","type":"function"},{"doc":"A module providing Internationalization with a gettext-based API. By using Gettext , our module gains a set of macros for translations, for example: import ZoonkWeb.Gettext # Simple translation gettext ( &quot;Here is the string to translate&quot; ) # Plural translation ngettext ( &quot;Here is the string to translate&quot; , &quot;Here are the strings to translate&quot; , 3 ) # Domain-based translation dgettext ( &quot;errors&quot; , &quot;Here is the error message to translate&quot; ) See the Gettext Docs for detailed usage.","ref":"ZoonkWeb.Gettext.html","title":"ZoonkWeb.Gettext","type":"module"},{"doc":"Callback implementation for Gettext.Backend.dgettext/3 .","ref":"ZoonkWeb.Gettext.html#dgettext/3","title":"ZoonkWeb.Gettext.dgettext/3","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dgettext_noop/2 .","ref":"ZoonkWeb.Gettext.html#dgettext_noop/2","title":"ZoonkWeb.Gettext.dgettext_noop/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dngettext/5 .","ref":"ZoonkWeb.Gettext.html#dngettext/5","title":"ZoonkWeb.Gettext.dngettext/5","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dngettext_noop/3 .","ref":"ZoonkWeb.Gettext.html#dngettext_noop/3","title":"ZoonkWeb.Gettext.dngettext_noop/3","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dpgettext/4 .","ref":"ZoonkWeb.Gettext.html#dpgettext/4","title":"ZoonkWeb.Gettext.dpgettext/4","type":"macro"},{"doc":"","ref":"ZoonkWeb.Gettext.html#dpgettext_noop/3","title":"ZoonkWeb.Gettext.dpgettext_noop/3","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dpngettext/6 .","ref":"ZoonkWeb.Gettext.html#dpngettext/6","title":"ZoonkWeb.Gettext.dpngettext/6","type":"macro"},{"doc":"","ref":"ZoonkWeb.Gettext.html#dpngettext_noop/4","title":"ZoonkWeb.Gettext.dpngettext_noop/4","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.gettext/2 .","ref":"ZoonkWeb.Gettext.html#gettext/2","title":"ZoonkWeb.Gettext.gettext/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.gettext_comment/1 .","ref":"ZoonkWeb.Gettext.html#gettext_comment/1","title":"ZoonkWeb.Gettext.gettext_comment/1","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.gettext_noop/1 .","ref":"ZoonkWeb.Gettext.html#gettext_noop/1","title":"ZoonkWeb.Gettext.gettext_noop/1","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.handle_missing_bindings/2 .","ref":"ZoonkWeb.Gettext.html#handle_missing_bindings/2","title":"ZoonkWeb.Gettext.handle_missing_bindings/2","type":"function"},{"doc":"Callback implementation for Gettext.Backend.handle_missing_plural_translation/7 .","ref":"ZoonkWeb.Gettext.html#handle_missing_plural_translation/7","title":"ZoonkWeb.Gettext.handle_missing_plural_translation/7","type":"function"},{"doc":"Callback implementation for Gettext.Backend.handle_missing_translation/5 .","ref":"ZoonkWeb.Gettext.html#handle_missing_translation/5","title":"ZoonkWeb.Gettext.handle_missing_translation/5","type":"function"},{"doc":"","ref":"ZoonkWeb.Gettext.html#lgettext/5","title":"ZoonkWeb.Gettext.lgettext/5","type":"function"},{"doc":"","ref":"ZoonkWeb.Gettext.html#lngettext/7","title":"ZoonkWeb.Gettext.lngettext/7","type":"function"},{"doc":"Callback implementation for Gettext.Backend.ngettext/4 .","ref":"ZoonkWeb.Gettext.html#ngettext/4","title":"ZoonkWeb.Gettext.ngettext/4","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.ngettext_noop/2 .","ref":"ZoonkWeb.Gettext.html#ngettext_noop/2","title":"ZoonkWeb.Gettext.ngettext_noop/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.pgettext/3 .","ref":"ZoonkWeb.Gettext.html#pgettext/3","title":"ZoonkWeb.Gettext.pgettext/3","type":"macro"},{"doc":"","ref":"ZoonkWeb.Gettext.html#pgettext_noop/2","title":"ZoonkWeb.Gettext.pgettext_noop/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.pngettext/5 .","ref":"ZoonkWeb.Gettext.html#pngettext/5","title":"ZoonkWeb.Gettext.pngettext/5","type":"macro"},{"doc":"","ref":"ZoonkWeb.Gettext.html#pngettext_noop/3","title":"ZoonkWeb.Gettext.pngettext_noop/3","type":"macro"},{"doc":"Privacy configuration.","ref":"ZoonkWeb.Privacy.html","title":"ZoonkWeb.Privacy","type":"module"},{"doc":"Returns the localized label from a list of privacy actions. Examples iex&gt; privacy_action_labels! ( [ :login_account , :contact_by_manager ] ) [ &quot;Allow to log in into your account&quot; , &quot;Allow school managers to contact you&quot; ] iex&gt; privacy_action_labels! ( [ :invalid ] ) ** (KeyError) key :invalid not found in:","ref":"ZoonkWeb.Privacy.html#privacy_action_labels!/1","title":"ZoonkWeb.Privacy.privacy_action_labels!/1","type":"function"},{"doc":"Returns the localized label from a list of privacy group keys. Examples iex&gt; privacy_group_labels! ( [ :school_managers , :teachers ] ) [ &quot;School managers&quot; , &quot;Teachers&quot; ] iex&gt; privacy_group_labels! ( [ :invalid ] ) ** (KeyError) key :invalid not found in:","ref":"ZoonkWeb.Privacy.html#privacy_group_labels!/1","title":"ZoonkWeb.Privacy.privacy_group_labels!/1","type":"function"},{"doc":"Returns the list of unauthorized privacy groups and their labels. This list is based on the list of authorized groups. It returns all groups that aren't listed as authorized. Examples iex&gt; unauthorized_group_labels! ( [ :school_managers , :teachers ] ) [ &quot;Students from your school&quot; , &quot;Students from other schools&quot; , ... ] iex&gt; unauthorized_group_labels! ( [ :invalid ] ) ** (KeyError) key :invalid not found in:","ref":"ZoonkWeb.Privacy.html#unauthorized_group_labels!/1","title":"ZoonkWeb.Privacy.unauthorized_group_labels!/1","type":"function"},{"doc":"Defines the application's routing logic using the Phoenix.Router module. See https://hexdocs.pm/phoenix/routing.html for more information.","ref":"ZoonkWeb.Router.html","title":"ZoonkWeb.Router","type":"module"},{"doc":"The API pipeline defines a set of plugs that are run for every request done to the API.","ref":"ZoonkWeb.Router.html#api/2","title":"ZoonkWeb.Router.api/2","type":"function"},{"doc":"The browser pipeline defines a set of plugs that are run for every request done in the browser.","ref":"ZoonkWeb.Router.html#browser/2","title":"ZoonkWeb.Router.browser/2","type":"function"},{"doc":"Callback invoked by Plug on every request.","ref":"ZoonkWeb.Router.html#call/2","title":"ZoonkWeb.Router.call/2","type":"function"},{"doc":"Callback required by Plug that initializes the router for serving web requests.","ref":"ZoonkWeb.Router.html#init/1","title":"ZoonkWeb.Router.init/1","type":"function"},{"doc":"User schema.","ref":"Zoonk.Accounts.User.html","title":"Zoonk.Accounts.User","type":"module"},{"doc":"Confirms the account by setting confirmed_at .","ref":"Zoonk.Accounts.User.html#confirm_changeset/1","title":"Zoonk.Accounts.User.confirm_changeset/1","type":"function"},{"doc":"A user changeset for changing the email. It requires the email to change otherwise an error is added.","ref":"Zoonk.Accounts.User.html#email_changeset/3","title":"Zoonk.Accounts.User.email_changeset/3","type":"function"},{"doc":"A user changeset for changing the password. Options :hash_password - Hashes the password so it can be stored securely in the database and ensures the password field is cleared to prevent leaks in the logs. If password hashing is not needed and clearing the password field is not desired (like when using this changeset for validations on a LiveView form), this option can be set to false . Defaults to true .","ref":"Zoonk.Accounts.User.html#password_changeset/3","title":"Zoonk.Accounts.User.password_changeset/3","type":"function"},{"doc":"A user changeset for registration. It is important to validate the length of both email and password. Otherwise databases may truncate the email without warnings, which could lead to unpredictable or insecure behaviour. Long passwords may also be very expensive to hash for certain algorithms. Options :hash_password - Hashes the password so it can be stored securely in the database and ensures the password field is cleared to prevent leaks in the logs. If password hashing is not needed and clearing the password field is not desired (like when using this changeset for validations on a LiveView form), this option can be set to false . Defaults to true . :validate_email - Validates the uniqueness of the email, in case you don't want to validate the uniqueness of the email (like when using this changeset for validations on a LiveView form before submitting the form), this option can be set to false . Defaults to true .","ref":"Zoonk.Accounts.User.html#registration_changeset/3","title":"Zoonk.Accounts.User.registration_changeset/3","type":"function"},{"doc":"A user changeset for changing the username.","ref":"Zoonk.Accounts.User.html#settings_changeset/3","title":"Zoonk.Accounts.User.settings_changeset/3","type":"function"},{"doc":"Verifies the password. If there is no user or the user doesn't have a password, we call Bcrypt.no_user_verify/0 to avoid timing attacks.","ref":"Zoonk.Accounts.User.html#valid_password?/2","title":"Zoonk.Accounts.User.valid_password?/2","type":"function"},{"doc":"Validates the current password otherwise adds an error to the changeset.","ref":"Zoonk.Accounts.User.html#validate_current_password/2","title":"Zoonk.Accounts.User.validate_current_password/2","type":"function"},{"doc":"","ref":"Zoonk.Accounts.User.html#t:t/0","title":"Zoonk.Accounts.User.t/0","type":"type"},{"doc":"Service for managing user emails.","ref":"Zoonk.Accounts.UserNotifier.html","title":"Zoonk.Accounts.UserNotifier","type":"module"},{"doc":"Deliver instructions to confirm account.","ref":"Zoonk.Accounts.UserNotifier.html#deliver_confirmation_instructions/2","title":"Zoonk.Accounts.UserNotifier.deliver_confirmation_instructions/2","type":"function"},{"doc":"Deliver instructions to reset a user password.","ref":"Zoonk.Accounts.UserNotifier.html#deliver_reset_password_instructions/2","title":"Zoonk.Accounts.UserNotifier.deliver_reset_password_instructions/2","type":"function"},{"doc":"Deliver instructions to update a user email.","ref":"Zoonk.Accounts.UserNotifier.html#deliver_update_email_instructions/2","title":"Zoonk.Accounts.UserNotifier.deliver_update_email_instructions/2","type":"function"},{"doc":"","ref":"Zoonk.Accounts.UserNotifier.html#t:deliver/0","title":"Zoonk.Accounts.UserNotifier.deliver/0","type":"type"},{"doc":"Token generation for user authentication.","ref":"Zoonk.Accounts.UserToken.html","title":"Zoonk.Accounts.UserToken","type":"module"},{"doc":"Builds a token and its hash to be delivered to the user's email. The non-hashed token is sent to the user email while the hashed part is stored in the database. The original token cannot be reconstructed, which means anyone with read-only access to the database cannot directly use the token in the application to gain access. Furthermore, if the user changes their email in the system, the tokens sent to the previous email are no longer valid. Users can easily adapt the existing code to provide other types of delivery methods, for example, by phone numbers.","ref":"Zoonk.Accounts.UserToken.html#build_email_token/2","title":"Zoonk.Accounts.UserToken.build_email_token/2","type":"function"},{"doc":"Generates a token that will be stored in a signed place, such as session or cookie. As they are signed, those tokens do not need to be hashed. The reason why we store session tokens in the database, even though Phoenix already provides a session cookie, is because Phoenix' default session cookies are not persisted, they are simply signed and potentially encrypted. This means they are valid indefinitely, unless you change the signing/encryption salt. Therefore, storing them allows individual user sessions to be expired. The token system can also be extended to store additional data, such as the device used for logging in. You could then use this information to display all valid sessions and devices in the UI and allow users to explicitly expire any session they deem invalid.","ref":"Zoonk.Accounts.UserToken.html#build_session_token/1","title":"Zoonk.Accounts.UserToken.build_session_token/1","type":"function"},{"doc":"Returns the token struct for the given token value and context.","ref":"Zoonk.Accounts.UserToken.html#token_and_context_query/2","title":"Zoonk.Accounts.UserToken.token_and_context_query/2","type":"function"},{"doc":"Gets all tokens for the given user for the given contexts.","ref":"Zoonk.Accounts.UserToken.html#user_and_contexts_query/2","title":"Zoonk.Accounts.UserToken.user_and_contexts_query/2","type":"function"},{"doc":"Checks if the token is valid and returns its underlying lookup query. The query returns the user found by the token, if any. This is used to validate requests to change the user email. It is different from verify_email_token_query/2 precisely because verify_email_token_query/2 validates the email has not changed, which is the starting point by this function. The given token is valid if it matches its hashed counterpart in the database and if it has not expired (after @change_email_validity_in_days). The context must always start with &quot;change:&quot;.","ref":"Zoonk.Accounts.UserToken.html#verify_change_email_token_query/2","title":"Zoonk.Accounts.UserToken.verify_change_email_token_query/2","type":"function"},{"doc":"Checks if the token is valid and returns its underlying lookup query. The query returns the user found by the token, if any. The given token is valid if it matches its hashed counterpart in the database and the user email has not changed. This function also checks if the token is being used within a certain period, depending on the context. The default contexts supported by this function are either &quot;confirm&quot;, for account confirmation emails, and &quot;reset_password&quot;, for resetting the password. For verifying requests to change the email, see verify_change_email_token_query/2 .","ref":"Zoonk.Accounts.UserToken.html#verify_email_token_query/2","title":"Zoonk.Accounts.UserToken.verify_email_token_query/2","type":"function"},{"doc":"Checks if the token is valid and returns its underlying lookup query. The query returns the user found by the token, if any. The token is valid if it matches the value in the database and it has not expired (after @session_validity_in_days).","ref":"Zoonk.Accounts.UserToken.html#verify_session_token_query/1","title":"Zoonk.Accounts.UserToken.verify_session_token_query/1","type":"function"},{"doc":"","ref":"Zoonk.Accounts.UserToken.html#t:t/0","title":"Zoonk.Accounts.UserToken.t/0","type":"type"},{"doc":"Course schema.","ref":"Zoonk.Content.Course.html","title":"Zoonk.Content.Course","type":"module"},{"doc":"","ref":"Zoonk.Content.Course.html#t:t/0","title":"Zoonk.Content.Course.t/0","type":"type"},{"doc":"Reusable configuration and utilities for courses.","ref":"Zoonk.Content.Course.Config.html","title":"Zoonk.Content.Course.Config","type":"module"},{"doc":"Returns the list of level keys.","ref":"Zoonk.Content.Course.Config.html#level_keys/0","title":"Zoonk.Content.Course.Config.level_keys/0","type":"function"},{"doc":"Returns a label for a given level key.","ref":"Zoonk.Content.Course.Config.html#level_label/1","title":"Zoonk.Content.Course.Config.level_label/1","type":"function"},{"doc":"Level options for displaying on a select component where the label is the key and the key is the value.","ref":"Zoonk.Content.Course.Config.html#level_options/0","title":"Zoonk.Content.Course.Config.level_options/0","type":"function"},{"doc":"Returns the list of supported levels for the course.","ref":"Zoonk.Content.Course.Config.html#levels/0","title":"Zoonk.Content.Course.Config.levels/0","type":"function"},{"doc":"Struct for defining a course's data. It's used in the course list page to display additional information about each course.","ref":"Zoonk.Content.CourseData.html","title":"Zoonk.Content.CourseData","type":"module"},{"doc":"","ref":"Zoonk.Content.CourseData.html#t:t/0","title":"Zoonk.Content.CourseData.t/0","type":"type"},{"doc":"Schema for the relationship between courses and users.","ref":"Zoonk.Content.CourseUser.html","title":"Zoonk.Content.CourseUser","type":"module"},{"doc":"","ref":"Zoonk.Content.CourseUser.html#t:t/0","title":"Zoonk.Content.CourseUser.t/0","type":"type"},{"doc":"Lesson schema.","ref":"Zoonk.Content.Lesson.html","title":"Zoonk.Content.Lesson","type":"module"},{"doc":"","ref":"Zoonk.Content.Lesson.html#t:t/0","title":"Zoonk.Content.Lesson.t/0","type":"type"},{"doc":"LessonStep schema.","ref":"Zoonk.Content.LessonStep.html","title":"Zoonk.Content.LessonStep","type":"module"},{"doc":"","ref":"Zoonk.Content.LessonStep.html#t:t/0","title":"Zoonk.Content.LessonStep.t/0","type":"type"},{"doc":"StepOption schema.","ref":"Zoonk.Content.StepOption.html","title":"Zoonk.Content.StepOption","type":"module"},{"doc":"","ref":"Zoonk.Content.StepOption.html#t:t/0","title":"Zoonk.Content.StepOption.t/0","type":"type"},{"doc":"School schema.","ref":"Zoonk.Organizations.School.html","title":"Zoonk.Organizations.School","type":"module"},{"doc":"","ref":"Zoonk.Organizations.School.html#t:t/0","title":"Zoonk.Organizations.School.t/0","type":"type"},{"doc":"Struct for defining a school's data. It's used in the school list page to display additional information about each school.","ref":"Zoonk.Organizations.SchoolData.html","title":"Zoonk.Organizations.SchoolData","type":"module"},{"doc":"","ref":"Zoonk.Organizations.SchoolData.html#t:t/0","title":"Zoonk.Organizations.SchoolData.t/0","type":"type"},{"doc":"Schema for the relationship between schools and users.","ref":"Zoonk.Organizations.SchoolUser.html","title":"Zoonk.Organizations.SchoolUser","type":"module"},{"doc":"","ref":"Zoonk.Organizations.SchoolUser.html#t:t/0","title":"Zoonk.Organizations.SchoolUser.t/0","type":"type"},{"doc":"Badge components.","ref":"ZoonkWeb.Components.Badge.html","title":"ZoonkWeb.Components.Badge","type":"module"},{"doc":"Renders a badge. Examples &lt; . badge &gt; 1 &lt; / . badge &gt; &lt; . badge color = { :alert } &gt; 2 &lt; / . badge &gt; &lt; . badge color = { :success } &gt; 3 &lt; / . badge &gt; &lt; . badge color = { :info } &gt; 4 &lt; / . badge &gt; &lt; . badge color = { :warning } &gt; 5 &lt; / . badge &gt; Attributes color ( :atom ) - the background color. Defaults to :info . icon ( :string ) (required) - name of the icon to add to the badge. class ( :string ) - the optional additional classes to add to the badge element. Defaults to nil . Global attributes are accepted. Slots inner_block (required) - the inner block that renders the badge content.","ref":"ZoonkWeb.Components.Badge.html#badge/1","title":"ZoonkWeb.Components.Badge.badge/1","type":"function"},{"doc":"Banner components.","ref":"ZoonkWeb.Components.Banner.html","title":"ZoonkWeb.Components.Banner","type":"module"},{"doc":"Renders a banner. Examples &lt; . banner title = &quot;My title&quot; icon = &quot;tabler-chevrons-up&quot; &gt; &lt; . section title = &quot;My section&quot; icon = &quot;tabler-chevrons-down&quot; entries = { [ &quot;My entry&quot; ] } / &gt; &lt; / . banner &gt; Attributes title ( :string ) (required) - Title displayed at the top of the banner. icon ( :string ) (required) - Icon displayed next to the title. open ( :boolean ) - Whether the banner is open or not when it first renders. This component uses the details HTML element, which is a collapsible element. So, we don't need to worry about manually opening and closing the banner. Defaults to false . Slots section - Accepts attributes: title ( :string ) (required) - Title displayed at the top of the section. icon ( :string ) (required) - Icon displayed next to the title. entries ( :list ) - List of entries to display.","ref":"ZoonkWeb.Components.Banner.html#banner/1","title":"ZoonkWeb.Components.Banner.banner/1","type":"function"},{"doc":"Button components.","ref":"ZoonkWeb.Components.Button.html","title":"ZoonkWeb.Components.Button","type":"module"},{"doc":"Renders a button. Examples &lt; . button &gt; Send ! &lt; / . button &gt; &lt; . button phx - click = &quot;go&quot; class = &quot;ml-2&quot; &gt; Send ! &lt; / . button &gt; Attributes color ( :atom ) - the background color. Defaults to :black . icon ( :string ) - name of the icon to add to the button. Defaults to nil . class ( :string ) - the optional additional classes to add to the button element. Defaults to nil . Global attributes are accepted. Slots inner_block (required) - the inner block that renders the button content.","ref":"ZoonkWeb.Components.Button.html#button/1","title":"ZoonkWeb.Components.Button.button/1","type":"function"},{"doc":"Renders a button with an icon only. Examples &lt; . icon_button icon = &quot;tabler-x&quot; label = &quot;Remove&quot; color = { :alert } / &gt; &lt; . icon_button icon = &quot;tabler-add&quot; label = &quot;Add&quot; phx - click = &quot;add&quot; / &gt; Attributes icon ( :string ) (required) - name of the icon to add to the button. label ( :string ) (required) - the button's label for screen readers. color ( :atom ) - the background color. Defaults to :black . size ( :atom ) - the button size. Defaults to :lg . Global attributes are accepted.","ref":"ZoonkWeb.Components.Button.html#icon_button/1","title":"ZoonkWeb.Components.Button.icon_button/1","type":"function"},{"doc":"Renders a button with a transparent background. Examples &lt; . transparent_button icon = &quot;tabler-x&quot; color = { :alert } phx - click = &quot;remove&quot; &gt; Remove &lt; / . transparent_button &gt; Attributes icon ( :string ) (required) - name of the icon to add to the button. color ( :atom ) - the background color. Defaults to :info . Global attributes are accepted. Slots inner_block (required) - the inner block that renders the button content.","ref":"ZoonkWeb.Components.Button.html#transparent_button/1","title":"ZoonkWeb.Components.Button.transparent_button/1","type":"function"},{"doc":"Form components.","ref":"ZoonkWeb.Components.Card.html","title":"ZoonkWeb.Components.Card","type":"module"},{"doc":"Renders a simple card. Examples &lt; . card &gt; card content &lt; / . card &gt; Attributes class ( :string ) - the form class. Defaults to nil . Slots inner_block (required)","ref":"ZoonkWeb.Components.Card.html#card/1","title":"ZoonkWeb.Components.Card.card/1","type":"function"},{"doc":"Reusable component for deleting items.","ref":"ZoonkWeb.Components.DeleteItem.html","title":"ZoonkWeb.Components.DeleteItem","type":"module"},{"doc":"Attributes id ( :string ) (required) name ( :string ) (required) cancel_link ( :string ) (required)","ref":"ZoonkWeb.Components.DeleteItem.html#render/1","title":"ZoonkWeb.Components.DeleteItem.render/1","type":"function"},{"doc":"Details component.","ref":"ZoonkWeb.Components.Details.html","title":"ZoonkWeb.Components.Details","type":"module"},{"doc":"Renders a details component. Examples &lt; . details title = &quot;Title&quot; &gt; &lt; p &gt; Content &lt; / p &gt; &lt; / . details &gt; Attributes title ( :string ) (required) - Title to be displayed even when the component is collapsed. class ( :string ) - Optional additional classes to add to the details element. Defaults to nil . Slots inner_block (required) - Content to be displayed when the component is expanded.","ref":"ZoonkWeb.Components.Details.html#details/1","title":"ZoonkWeb.Components.Details.details/1","type":"function"},{"doc":"Dropdown components.","ref":"ZoonkWeb.Components.Dropdown.html","title":"ZoonkWeb.Components.Dropdown","type":"module"},{"doc":"Returns a button triggered dropdown with aria keyboard and focus supporrt. Accepts the follow slots: :id - The id to uniquely identify this dropdown :img - The optional img to show beside the button title :title - The button title :subtitle - The button subtitle Examples &lt; . user_dropdown id = { @id } &gt; &lt; :img src = { @current_user . avatar_url } / &gt; &lt; :title &gt; &lt; % = @current_user . name % &gt; &lt; / :title &gt; &lt; :subtitle &gt; @ &lt; % = @current_user . username % &gt; &lt; / :subtitle &gt; &lt; :link navigate = { profile_path ( @current_user ) } &gt; View Profile &lt; / :link &gt; &lt; :link navigate = { ~p&quot;/profile/settings&quot; } Settings &lt; / :link &gt; &lt; / . dropdown &gt; Attributes id ( :string ) (required) - the dropdown id. Slots img - Accepts attributes: src ( :string ) alt ( :string ) title - the title displayed on the clickable dropdown button. subtitle - the subtitle displayed on the clickable dropdown button. link - list of links to be displayed when the dropdown is open. Accepts attributes: navigate ( :string ) href ( :string ) method ( :any ) color ( :atom ) - Must be one of :black , or :alert .","ref":"ZoonkWeb.Components.Dropdown.html#dropdown/1","title":"ZoonkWeb.Components.Dropdown.dropdown/1","type":"function"},{"doc":"","ref":"ZoonkWeb.Components.Dropdown.html#hide_dropdown/1","title":"ZoonkWeb.Components.Dropdown.hide_dropdown/1","type":"function"},{"doc":"","ref":"ZoonkWeb.Components.Dropdown.html#show_dropdown/1","title":"ZoonkWeb.Components.Dropdown.show_dropdown/1","type":"function"},{"doc":"Flash components.","ref":"ZoonkWeb.Components.Flash.html","title":"ZoonkWeb.Components.Flash","type":"module"},{"doc":"Renders flash notices. Examples &lt; . flash kind = { :info } flash = { @flash } / &gt; &lt; . flash kind = { :info } phx - mounted = { show ( &quot;#flash&quot; ) } &gt; Welcome Back ! &lt; / . flash &gt; Attributes id ( :string ) - the optional id of flash container. Defaults to &quot;flash&quot; . flash ( :map ) - the map of flash messages to display. Defaults to %{} . title ( :string ) - Defaults to nil . kind ( :atom ) - used for styling and flash lookup.Must be one of :info , or :error . Global attributes are accepted. Slots inner_block - the optional inner block that renders the flash message.","ref":"ZoonkWeb.Components.Flash.html#flash/1","title":"ZoonkWeb.Components.Flash.flash/1","type":"function"},{"doc":"Shows the flash group with standard titles and content. Examples &lt; . flash_group flash = { @flash } / &gt; Attributes flash ( :map ) (required) - the map of flash messages.","ref":"ZoonkWeb.Components.Flash.html#flash_group/1","title":"ZoonkWeb.Components.Flash.flash_group/1","type":"function"},{"doc":"Form components.","ref":"ZoonkWeb.Components.Form.html","title":"ZoonkWeb.Components.Form","type":"module"},{"doc":"Renders a simple form. Examples &lt; . simple_form for = { @form } phx - change = &quot;validate&quot; phx - submit = &quot;save&quot; &gt; &lt; . input field = { @form [ :email ] } label = &quot;Email&quot; / &gt; &lt; . input field = { @form [ :username ] } label = &quot;Username&quot; / &gt; &lt; :actions &gt; &lt; . button &gt; Save &lt; / . button &gt; &lt; / :actions &gt; &lt; / . simple_form &gt; Attributes for ( :any ) (required) - the datastructure for the form. as ( :any ) - the server side parameter to collect all input under. Defaults to nil . title ( :string ) - the form title displayed before the form. Defaults to nil . subtitle ( :string ) - the form subtitle displayed before the form. Defaults to nil . class ( :string ) - the form class. Defaults to nil . unstyled ( :boolean ) - whether to remove the default styling to the form. Defaults to false . Global attributes are accepted. Slots inner_block (required) actions - the slot for form actions, such as a submit button.","ref":"ZoonkWeb.Components.Form.html#simple_form/1","title":"ZoonkWeb.Components.Form.simple_form/1","type":"function"},{"doc":"Header components.","ref":"ZoonkWeb.Components.Header.html","title":"ZoonkWeb.Components.Header","type":"module"},{"doc":"Renders a header with title. Attributes class ( :string ) - the optional additional classes to add to the header element. Defaults to nil . icon ( :string ) - the optional icon name to add to the header element. Defaults to nil . Slots inner_block (required) - the inner block that renders the header content. subtitle - renders a subtitle under the header content. actions - renders a slot for actions, such as a button, at the bottom of the header.","ref":"ZoonkWeb.Components.Header.html#header/1","title":"ZoonkWeb.Components.Header.header/1","type":"function"},{"doc":"Icon components.","ref":"ZoonkWeb.Components.Icon.html","title":"ZoonkWeb.Components.Icon","type":"module"},{"doc":"Renders a Tabler Icon . Icons are extracted from our assets/vendor/tabler directory and bundled within our compiled app.css by the plugin in your assets/tailwind.config.js . Examples &lt; . icon name = &quot;tabler-x&quot; / &gt; &lt; . icon name = &quot;tabler-refresh&quot; class = &quot;ml-1 w-3 h-3 animate-spin&quot; / &gt; Attributes name ( :string ) (required) - the name of the icon from the tabler library. class ( :string ) - the optional additional classes to add to the icon element. Defaults to nil . gradient ( :boolean ) - whether to add a gradient color to the icon. Defaults to false . Global attributes are accepted.","ref":"ZoonkWeb.Components.Icon.html#icon/1","title":"ZoonkWeb.Components.Icon.icon/1","type":"function"},{"doc":"Image components.","ref":"ZoonkWeb.Components.Image.html","title":"ZoonkWeb.Components.Image","type":"module"},{"doc":"Renders an avatar element. Examples &lt; . avatar alt = &quot;John Doe&quot; / &gt; &lt; . avatar alt = &quot;John Doe&quot; src = &quot;https://example.com/image.jpg&quot; / &gt; Attributes src ( :string ) - the image source. Defaults to nil . alt ( :string ) (required) - the image alt text. It can be used as a fallback if the image is not available. size ( :atom ) - the size of the avatar. Defaults to :medium . class ( :string ) - the class of the avatar. Defaults to nil .","ref":"ZoonkWeb.Components.Image.html#avatar/1","title":"ZoonkWeb.Components.Image.avatar/1","type":"function"},{"doc":"Input components.","ref":"ZoonkWeb.Components.Input.html","title":"ZoonkWeb.Components.Input","type":"module"},{"doc":"Generates a generic error message. Slots inner_block (required)","ref":"ZoonkWeb.Components.Input.html#error/1","title":"ZoonkWeb.Components.Input.error/1","type":"function"},{"doc":"Renders a helper text. Slots inner_block (required)","ref":"ZoonkWeb.Components.Input.html#helper/1","title":"ZoonkWeb.Components.Input.helper/1","type":"function"},{"doc":"Renders an input with label and error messages. A %Form{} and field name may be passed to the input to build input names and error messages, or all the attributes and errors may be passed explicitly. Examples &lt; . input field = { @form [ :email ] } type = &quot;email&quot; / &gt; &lt; . input name = &quot;my-input&quot; errors = { [ &quot;oh no!&quot; ] } / &gt; Attributes id ( :any ) - the id of the input. Defaults to nil . name ( :any ) - the name of the input. label ( :string ) - the label of the input. Defaults to nil . value ( :any ) - the value of the input. helper ( :string ) - a helper text to be displayed with the input. Defaults to nil . type ( :string ) - Defaults to &quot;text&quot; . field ( Phoenix.HTML.FormField ) - a form field struct retrieved from the form, for example: @form[:email]. errors ( :list ) - the errors to display for the input. Defaults to [] . checked ( :boolean ) - the checked flag for checkbox inputs. prompt ( :string ) - the prompt for select inputs. Defaults to nil . options ( :list ) - the options to pass to Form.options_for_select/2. multiple ( :boolean ) - the multiple flag for select inputs. Defaults to false . Global attributes are accepted. Slots inner_block - the inner block of the input.","ref":"ZoonkWeb.Components.Input.html#input/1","title":"ZoonkWeb.Components.Input.input/1","type":"function"},{"doc":"Renders a label. Attributes for ( :string ) - Defaults to nil . Slots inner_block (required)","ref":"ZoonkWeb.Components.Input.html#label/1","title":"ZoonkWeb.Components.Input.label/1","type":"function"},{"doc":"Translates an error message using gettext.","ref":"ZoonkWeb.Components.Input.html#translate_error/1","title":"ZoonkWeb.Components.Input.translate_error/1","type":"function"},{"doc":"Link components.","ref":"ZoonkWeb.Components.Link.html","title":"ZoonkWeb.Components.Link","type":"module"},{"doc":"Renders a link but styled like a button. Attributes color ( :atom ) - Defaults to :black . class ( :string ) - Defaults to nil . icon ( :string ) - Defaults to nil . Global attributes are accepted. Slots inner_block","ref":"ZoonkWeb.Components.Link.html#link_button/1","title":"ZoonkWeb.Components.Link.link_button/1","type":"function"},{"doc":"Renders a styled link using our default style guide. Attributes color ( :atom ) - the color of the link. Defaults to :primary . class ( :string ) - the optional additional classes to add to the header element. Defaults to nil . Global attributes are accepted. Slots inner_block (required)","ref":"ZoonkWeb.Components.Link.html#link_styled/1","title":"ZoonkWeb.Components.Link.link_styled/1","type":"function"},{"doc":"List components.","ref":"ZoonkWeb.Components.List.html","title":"ZoonkWeb.Components.List","type":"module"},{"doc":"Renders a data list. Examples &lt; . list &gt; &lt; :item title = &quot;Title&quot; &gt; &lt; % = @post . title % &gt; &lt; / :item &gt; &lt; :item title = &quot;Views&quot; &gt; &lt; % = @post . views % &gt; &lt; / :item &gt; &lt; / . list &gt; Slots item (required) - Accepts attributes: title ( :string ) (required)","ref":"ZoonkWeb.Components.List.html#list/1","title":"ZoonkWeb.Components.List.list/1","type":"function"},{"doc":"Modal components.","ref":"ZoonkWeb.Components.Modal.html","title":"ZoonkWeb.Components.Modal","type":"module"},{"doc":"Hides a modal.","ref":"ZoonkWeb.Components.Modal.html#hide_modal/2","title":"ZoonkWeb.Components.Modal.hide_modal/2","type":"function"},{"doc":"Renders a modal. Examples &lt; . modal id = &quot;confirm-modal&quot; &gt; This is a modal . &lt; / . modal &gt; JS commands may be passed to the :on_cancel to configure the closing/cancel event, for example: &lt; . modal id = &quot;confirm&quot; on_cancel = { JS . navigate ( ~p&quot;/posts&quot; ) } &gt; This is another modal . &lt; / . modal &gt; Attributes id ( :string ) (required) - the id of the modal container. show ( :boolean ) - whether to show the modal on mount. Defaults to false . on_cancel ( Phoenix.LiveView.JS ) - the JS command to run when the modal is canceled. Defaults to %Phoenix.LiveView.JS{ops: []} . Slots inner_block (required) - the inner block that renders the modal content. actions - the slot for modal actions, such as a confirm and cancel.","ref":"ZoonkWeb.Components.Modal.html#modal/1","title":"ZoonkWeb.Components.Modal.modal/1","type":"function"},{"doc":"Shows a modal.","ref":"ZoonkWeb.Components.Modal.html#show_modal/2","title":"ZoonkWeb.Components.Modal.show_modal/2","type":"function"},{"doc":"Reusable components for managing privacy configurations.","ref":"ZoonkWeb.Components.Privacy.html","title":"ZoonkWeb.Components.Privacy","type":"module"},{"doc":"Display a summary of the current privacy settings for a given feature. Attributes open ( :boolean ) - Defaults to false . authorized ( :list ) - Defaults to [] . actions ( :list ) - Defaults to [] . notes ( :list ) - Defaults to [] .","ref":"ZoonkWeb.Components.Privacy.html#privacy_info/1","title":"ZoonkWeb.Components.Privacy.privacy_info/1","type":"function"},{"doc":"Tab components.","ref":"ZoonkWeb.Components.Tab.html","title":"ZoonkWeb.Components.Tab","type":"module"},{"doc":"Attributes type ( :atom ) - Type of tab to render. Defaults to :main_menu . title ( :string ) (required) - Tab title. Slots inner_block (required) - Inner block of the tab.","ref":"ZoonkWeb.Components.Tab.html#tab/1","title":"ZoonkWeb.Components.Tab.tab/1","type":"function"},{"doc":"Renders a tab item. Examples &lt; . tab_item active = { @live_action == :school_list } navigate = { ~p&quot;/schools&quot; } icon = &quot;tabler-school&quot; title = &quot;Schools&quot; / &gt; Attributes active ( :boolean ) - Whether the tab is active or not. Defaults to false . icon ( :string ) (required) - Icon displayed above the title. title ( :string ) (required) - Tab title. adapt_on_desktop ( :boolean ) - Whether to adapt the tab on desktop. Defaults to false . Global attributes are accepted.","ref":"ZoonkWeb.Components.Tab.html#tab_item/1","title":"ZoonkWeb.Components.Tab.tab_item/1","type":"function"},{"doc":"Table components.","ref":"ZoonkWeb.Components.Table.html","title":"ZoonkWeb.Components.Table","type":"module"},{"doc":"Renders a table with generic styling. Examples &lt; . table id = &quot;users&quot; rows = { @users } &gt; &lt; :col :let = { user } label = &quot;id&quot; &gt; &lt; % = user . id % &gt; &lt; / :col &gt; &lt; :col :let = { user } label = &quot;username&quot; &gt; &lt; % = user . username % &gt; &lt; / :col &gt; &lt; / . table &gt; Attributes id ( :string ) (required) - the id of the table. rows ( :list ) (required) - the rows to display in the table. row_id ( :any ) - the function for generating the row id. Defaults to nil . row_click ( :any ) - the function for handling phx-click on each row. Defaults to nil . row_item ( :any ) - the function for mapping each row before calling the :col and :action slots. Defaults to &amp;Function.identity/1 . Slots col (required) - Accepts attributes: label ( :string ) action - the slot for showing user actions in the last table column.","ref":"ZoonkWeb.Components.Table.html#table/1","title":"ZoonkWeb.Components.Table.table/1","type":"function"},{"doc":"Reusable file upload component.","ref":"ZoonkWeb.Components.Upload.html","title":"ZoonkWeb.Components.Upload","type":"module"},{"doc":"Attributes current_img ( :string ) - Defaults to nil . label ( :string ) - Defaults to nil . unstyled ( :boolean ) - Defaults to false .","ref":"ZoonkWeb.Components.Upload.html#render/1","title":"ZoonkWeb.Components.Upload.render/1","type":"function"},{"doc":"Utils to be used in function components.","ref":"ZoonkWeb.Components.Utils.html","title":"ZoonkWeb.Components.Utils","type":"module"},{"doc":"Hides a HTML element with a transition.","ref":"ZoonkWeb.Components.Utils.html#hide/2","title":"ZoonkWeb.Components.Utils.hide/2","type":"function"},{"doc":"Shows a HTML element with a transition.","ref":"ZoonkWeb.Components.Utils.html#show/2","title":"ZoonkWeb.Components.Utils.show/2","type":"function"},{"doc":"Renders a page warning users that they don't meet the minimum age requirement. This page is rendered when a route doesn't pass the checks done by the ZoonkWeb.Plugs.AgeChecker plug.","ref":"ZoonkWeb.Controller.Accounts.Age.html","title":"ZoonkWeb.Controller.Accounts.Age","type":"module"},{"doc":"Renders the page. This is reponsible for: Setting the page title Rendering the page using the auth layout to avoid showing the main navigation.","ref":"ZoonkWeb.Controller.Accounts.Age.html#index/2","title":"ZoonkWeb.Controller.Accounts.Age.index/2","type":"function"},{"doc":"Handles all authentication actions.","ref":"ZoonkWeb.Controller.Accounts.UserSession.html","title":"ZoonkWeb.Controller.Accounts.UserSession","type":"module"},{"doc":"","ref":"ZoonkWeb.Controller.Accounts.UserSession.html#create/2","title":"ZoonkWeb.Controller.Accounts.UserSession.create/2","type":"function"},{"doc":"","ref":"ZoonkWeb.Controller.Accounts.UserSession.html#delete/2","title":"ZoonkWeb.Controller.Accounts.UserSession.delete/2","type":"function"},{"doc":"This module is used to set the active tab to the socket.","ref":"ZoonkWeb.Plugs.ActiveTab.html","title":"ZoonkWeb.Plugs.ActiveTab","type":"module"},{"doc":"","ref":"ZoonkWeb.Plugs.ActiveTab.html#on_mount/4","title":"ZoonkWeb.Plugs.ActiveTab.on_mount/4","type":"function"},{"doc":"Check if a user has reached the required age to view this application.","ref":"ZoonkWeb.Plugs.AgeChecker.html","title":"ZoonkWeb.Plugs.AgeChecker","type":"module"},{"doc":"Redirect users when they don't meet the minimum age requirement.","ref":"ZoonkWeb.Plugs.AgeChecker.html#age_check/2","title":"ZoonkWeb.Plugs.AgeChecker.age_check/2","type":"function"},{"doc":"Only users who are 13 years old or older can view this application.","ref":"ZoonkWeb.Plugs.AgeChecker.html#authorized?/1","title":"ZoonkWeb.Plugs.AgeChecker.authorized?/1","type":"function"},{"doc":"Mounts the course data and permissions.","ref":"ZoonkWeb.Plugs.Course.html","title":"ZoonkWeb.Plugs.Course","type":"module"},{"doc":"Fetches the course's data from the database.","ref":"ZoonkWeb.Plugs.Course.html#fetch_course/2","title":"ZoonkWeb.Plugs.Course.fetch_course/2","type":"function"},{"doc":"Handles mounting the course data to a LiveView. on_mount options :mount_course - Mounts the course from the course_slug paramater. :mount_lesson - Mounts the lesson from the lesson_id paramater.","ref":"ZoonkWeb.Plugs.Course.html#on_mount/4","title":"ZoonkWeb.Plugs.Course.on_mount/4","type":"function"},{"doc":"Requires a school manager or course teacher to access a page.","ref":"ZoonkWeb.Plugs.Course.html#require_manager_or_course_teacher/2","title":"ZoonkWeb.Plugs.Course.require_manager_or_course_teacher/2","type":"function"},{"doc":"Update Phoenix's headers to include additional secure browser headers such like the Content Security Policy .","ref":"ZoonkWeb.Plugs.CustomSecureBrowserHeaders.html","title":"ZoonkWeb.Plugs.CustomSecureBrowserHeaders","type":"module"},{"doc":"","ref":"ZoonkWeb.Plugs.CustomSecureBrowserHeaders.html#call/2","title":"ZoonkWeb.Plugs.CustomSecureBrowserHeaders.call/2","type":"function"},{"doc":"","ref":"ZoonkWeb.Plugs.CustomSecureBrowserHeaders.html#init/1","title":"ZoonkWeb.Plugs.CustomSecureBrowserHeaders.init/1","type":"function"},{"doc":"This is a multi-tenant app where we assign schools depending on the host value. Examples app.zoonk.org -&gt; zoonk school davinci.zoonk.org -&gt; davinci school interactive.harvard.edu -&gt; harvard school This means we need to fetch the app school's data when starting this application.","ref":"ZoonkWeb.Plugs.School.html","title":"ZoonkWeb.Plugs.School","type":"module"},{"doc":"Fetches the school's data from the database.","ref":"ZoonkWeb.Plugs.School.html#fetch_school/2","title":"ZoonkWeb.Plugs.School.fetch_school/2","type":"function"},{"doc":"Only allows a route if coming from the marketplace.","ref":"ZoonkWeb.Plugs.School.html#marketplace_only/2","title":"ZoonkWeb.Plugs.School.marketplace_only/2","type":"function"},{"doc":"Handles mounting the school data to a LiveView. on_mount options :mount_school - Mounts the school from the school_username param and the host .","ref":"ZoonkWeb.Plugs.School.html#on_mount/4","title":"ZoonkWeb.Plugs.School.on_mount/4","type":"function"},{"doc":"When running the app for the first time, there won't be any schools assigned to the host . In those cases, we need to redirect the user to the setup page instead.","ref":"ZoonkWeb.Plugs.School.html#redirect_to_setup_school/2","title":"ZoonkWeb.Plugs.School.redirect_to_setup_school/2","type":"function"},{"doc":"Requires authentication for private schools. Some schools set their visibility to false through school.public? . In those cases none of the school pages should be publicly visible.","ref":"ZoonkWeb.Plugs.School.html#require_auth_for_private_schools/2","title":"ZoonkWeb.Plugs.School.require_auth_for_private_schools/2","type":"function"},{"doc":"Requires manager permissions to access a certain route.","ref":"ZoonkWeb.Plugs.School.html#require_manager/2","title":"ZoonkWeb.Plugs.School.require_manager/2","type":"function"},{"doc":"Requires manager or teacher permissions to access a certain route.","ref":"ZoonkWeb.Plugs.School.html#require_manager_or_teacher/2","title":"ZoonkWeb.Plugs.School.require_manager_or_teacher/2","type":"function"},{"doc":"Requires a subscription for private schools.","ref":"ZoonkWeb.Plugs.School.html#require_subscription_for_private_schools/2","title":"ZoonkWeb.Plugs.School.require_subscription_for_private_schools/2","type":"function"},{"doc":"Reusable functions for setting up multiple languages and translations.","ref":"ZoonkWeb.Plugs.Translate.html","title":"ZoonkWeb.Plugs.Translate","type":"module"},{"doc":"Get the browser's locale. This is a naive implementation that only takes the first locale from the accept-language header. If it's not supported by this application, it will return the @default_locale .","ref":"ZoonkWeb.Plugs.Translate.html#get_browser_locale/1","title":"ZoonkWeb.Plugs.Translate.get_browser_locale/1","type":"function"},{"doc":"Language options for displaying on a select component where the label is the key and the key is the value.","ref":"ZoonkWeb.Plugs.Translate.html#language_options/0","title":"ZoonkWeb.Plugs.Translate.language_options/0","type":"function"},{"doc":"Get user's defined locale and set it to Gettext . When the user hasn't defined a locale it, we use the one defined at the current session.","ref":"ZoonkWeb.Plugs.Translate.html#on_mount/4","title":"ZoonkWeb.Plugs.Translate.on_mount/4","type":"function"},{"doc":"Plug for adding a locale to the current session. current_user : Use the locale set by the user in their settings. unauthenticated : Use the browser's locale.","ref":"ZoonkWeb.Plugs.Translate.html#set_session_locale/2","title":"ZoonkWeb.Plugs.Translate.set_session_locale/2","type":"function"},{"doc":"List all keys for supported languages.","ref":"ZoonkWeb.Plugs.Translate.html#supported_locales/0","title":"ZoonkWeb.Plugs.Translate.supported_locales/0","type":"function"},{"doc":"Handles user authentication.","ref":"ZoonkWeb.Plugs.UserAuth.html","title":"ZoonkWeb.Plugs.UserAuth","type":"module"},{"doc":"Authenticates the user by looking into the session and remember me token.","ref":"ZoonkWeb.Plugs.UserAuth.html#fetch_current_user/2","title":"ZoonkWeb.Plugs.UserAuth.fetch_current_user/2","type":"function"},{"doc":"Logs the user in. It renews the session ID and clears the whole session to avoid fixation attacks. See the renew_session function to customize this behaviour. It also sets a :live_socket_id key in the session, so LiveView sessions are identified and automatically disconnected on log out. The line can be safely removed if you are not using LiveView.","ref":"ZoonkWeb.Plugs.UserAuth.html#log_in_user/3","title":"ZoonkWeb.Plugs.UserAuth.log_in_user/3","type":"function"},{"doc":"Logs the user out. It clears all session data for safety. See renew_session.","ref":"ZoonkWeb.Plugs.UserAuth.html#log_out_user/1","title":"ZoonkWeb.Plugs.UserAuth.log_out_user/1","type":"function"},{"doc":"Handles mounting and authenticating the current_user in LiveViews. on_mount arguments :mount_current_user - Assigns current_user to socket assigns based on user_token, or nil if there's no user_token or no matching user. :ensure_authenticated - Authenticates the user from the session, and assigns the current_user to socket assigns based on user_token. Redirects to login page if there's no logged user. :redirect_if_user_is_authenticated - Authenticates the user from the session. Redirects to signed_in_path if there's a logged user. Examples Use the on_mount lifecycle macro in LiveViews to mount or authenticate the current_user: defmodule ZoonkWeb.PageLive do use ZoonkWeb , :live_view on_mount { ZoonkWeb.Plugs.UserAuth , :mount_current_user } ... end Or use the live_session of your router to invoke the on_mount callback: live_session :authenticated , on_mount : [ { ZoonkWeb.Plugs.UserAuth , :ensure_authenticated } ] do live &quot;/profile&quot; , ProfileLive , :index end","ref":"ZoonkWeb.Plugs.UserAuth.html#on_mount/4","title":"ZoonkWeb.Plugs.UserAuth.on_mount/4","type":"function"},{"doc":"Used for routes that require the user to not be authenticated.","ref":"ZoonkWeb.Plugs.UserAuth.html#redirect_if_user_is_authenticated/2","title":"ZoonkWeb.Plugs.UserAuth.redirect_if_user_is_authenticated/2","type":"function"},{"doc":"Used for routes that require the user to be authenticated. If you want to enforce the user email is confirmed before they use the application at all, here would be a good place.","ref":"ZoonkWeb.Plugs.UserAuth.html#require_authenticated_user/2","title":"ZoonkWeb.Plugs.UserAuth.require_authenticated_user/2","type":"function"},{"doc":"Reusable logic for building multistep forms.","ref":"ZoonkWeb.Shared.MultistepForm.html","title":"ZoonkWeb.Shared.MultistepForm","type":"module"},{"doc":"Slug module for generating slugs. Forked from https://github.com/norbajunior/slugy","ref":"ZoonkWeb.Shared.Slug.html","title":"ZoonkWeb.Shared.Slug","type":"module"},{"doc":"Generate a slug from a string.","ref":"ZoonkWeb.Shared.Slug.html#slug/1","title":"ZoonkWeb.Shared.Slug.slug/1","type":"function"},{"doc":"Shared validators to be used with Ecto changesets.","ref":"ZoonkWeb.Shared.Validators.html","title":"ZoonkWeb.Shared.Validators","type":"module"},{"doc":"Validates a field doesn't contain spaces or special characters other than - and _ . It should also return an error for accented characters.","ref":"ZoonkWeb.Shared.Validators.html#validate_slug/2","title":"ZoonkWeb.Shared.Validators.validate_slug/2","type":"function"},{"doc":"🚧 Under construction 🚧 This project is a work in progress. We're building it in public. It should NOT be used yet. Zoonk is an open-source platform for creating interactive courses. Our main goal is to provide an easy way to create interactive, engaging learning experiences that moves us away from the traditional &quot;text and video&quot; approach. We believe that learning should be fun and hands-on. You can learn more about our approach and goals on our website .","ref":"overview.html","title":"Overview","type":"extras"},{"doc":"","ref":"installation.html","title":"Installation","type":"extras"},{"doc":"You need Elixir 1.14 or later and Erlang 25 or later. Run elixir -v to find your current version for Elixir and Erlang . Install Hex : mix local.hex . Install Phoenix : mix archive.install hex phx_new . PostgreSQL 15+ . (Linux users only): inotify-tools .","ref":"installation.html#requirements","title":"Installation - Requirements","type":"extras"},{"doc":"Install dependencies and set up both the database and assets: mix setup .","ref":"installation.html#getting-started","title":"Installation - Getting started","type":"extras"},{"doc":"Start a local server: mix phx.server (it will run on https://localhost:4001 or https://zoonk.io:4001 - see the SSL guide for more information). Run tests: mix test . Update translation files: mix locale .","ref":"installation.html#local-development","title":"Installation - Local development","type":"extras"},{"doc":"Prefer to do local development using SSL to resemble production as much as possible. Phoenix has a generator for creating a self-signed certificate for HTTPS testing: mix phx.gen.cert . However, when using Phoenix's generator you'll still have a &quot;non secure&quot; warning. To get rid of that warning, you can generate a certificate using mkcert . After you install mkcert , follow the steps below: Create a cert directory under priv : mkdir priv/cert . Generate a new certificate: mkcert -key-file priv/cert/selfsigned_key.pem -cert-file priv/cert/selfsigned.pem localhost . Restart your local server: mix phx.server . You may also need to restart your browser. Zoonk is a multi-tenant app. Multiple schools can visit this app using their custom domain or our subdomain (i.e. username.zoonk.io ). Therefore, it's useful to test those domains locally. You can do so by following the steps below:","ref":"ssl.html","title":"SSL","type":"extras"},{"doc":"dnsmasq allows you to resolve domains to your local machine without having to change your /etc/hosts file. To install dnsmasq : brew install dnsmasq # Create a configuration directory mkdir -pv $(brew --prefix)/etc/ # Set up your domains echo &#39;address=/zoonk.io/127.0.0.1&#39; &gt;&gt; $(brew --prefix)/etc/dnsmasq.conf echo &#39;address=/.zoonk.io/127.0.0.1&#39; &gt;&gt; $(brew --prefix)/etc/dnsmasq.conf # Start dnsmasq sudo brew services start dnsmasq # Add dnsmasq to your resolver sudo mkdir -v /etc/resolver sudo bash -c &#39;echo &quot;nameserver 127.0.0.1&quot; &gt; /etc/resolver/zoonk.io&#39; Note: After changing your dnsmasq.conf file, you'll need to restart dnsmasq","ref":"ssl.html#setting-up-dnsmasq","title":"SSL - Setting up dnsmasq","type":"extras"},{"doc":"You can use mkcert to generate a certificate for each domain. In the example below, we're going to use the same domains as above: mkcert -key-file priv/cert/selfsigned_key.pem -cert-file priv/cert/selfsigned.pem localhost zoonk.io &quot;*.zoonk.io&quot;","ref":"ssl.html#generate-a-certificate-for-each-domain","title":"SSL - Generate a certificate for each domain","type":"extras"},{"doc":"That's it! You can now start your local server ( mix phx.server ) and test your domains using: https://zoonk.io:4001 https://rug.zoonk.io:4001 (each school username can be used as a subdomain of zoonk.io) Or any other domain you added before.","ref":"ssl.html#start-your-local-server","title":"SSL - Start your local server","type":"extras"},{"doc":"When you're setting up Zoonk for the first time, we'll guide you into creating an account that will have manager permissions. There are three kind of roles users can have: Manager : Can manage everything in their school: school information, users, courses, etc. Teacher : Can manage courses and students. Student : Can only view courses.","ref":"permissions.html","title":"Permissions","type":"extras"},{"doc":"When you run mix setup , we add some seed data for you. This is helpful for testing different functionality such as user roles. The users below are created for you (password is always Demo1234 ): School Public? Language Domain Subdomain Managers Teachers Zoonk Yes English zoonk.io - einstein curie , newton RUG Yes English interactive.rug.nl rug.zoonk.io franklin pasteur , goodall AMNH Yes English interactive.amnh.org amnh.zoonk.io faraday mcclintock , turing SB No English learning.standardbots.com standardbots.zoonk.io tesla franklin , pasteur BXS No English interactive.bxscience.edu bxscience.zoonk.io edison lamarr , faraday Unisc Yes Portuguese interativo.unisc.br unisc.zoonk.io tereshkova darwin , hamilton MDA Yes Portuguese i.museudoamanha.org.br museudoamanha.zoonk.io payne halley , bialik BB No Portuguese aulas.bb.com.br bb.zoonk.io sagan jemison , bohr Marista No Portuguese aulas.marista.edu.br marista.zoonk.io guth cori , bellburnell","ref":"permissions.html#default-users","title":"Permissions - Default users","type":"extras"},{"doc":"Users can request to join private schools. When they do so, they'll be added to the school as a non-approved user. Non-approved users can't access the school's content. Managers can see pending users on the &quot;managers&quot;, &quot;teachers&quot;, and &quot;students&quot; pages. They can approve or reject users from there. When a user is approved, they'll be able to access the school's content. Otherwise, they'll be removed from the school.","ref":"permissions.html#approved-vs-non-approved-users","title":"Permissions - Approved vs non-approved users","type":"extras"},{"doc":"Schools can be private or public. Public schools are open to anyone. Private schools are only accessible to users who are approved by the school's managers.","ref":"permissions.html#private-vs-public-schools","title":"Permissions - Private vs public schools","type":"extras"},{"doc":"Courses can be private or public. Public courses are open to anyone within the school . If the school is public, this means anyone can see all public courses. However, if the school is private, then only school members can see public courses. Private courses are only accessible to users who are approved by the course's teachers.","ref":"permissions.html#public-vs-private-courses","title":"Permissions - Public vs private courses","type":"extras"},{"doc":"Courses can be published or unpublished. Published courses are visible to students. Unpublished courses are only visible to teachers and managers. Unpublished courses are useful as a way to draft a course before publishing it.","ref":"permissions.html#published-vs-unpublished-courses","title":"Permissions - Published vs unpublished courses","type":"extras"}]